#include "gps.h"


void SPI_MasterInit(void)
{
	/* Set MOSI, SCK, SS_INV output, all others input */
	DDRB = (1<<DDB2)|(1<<DDB1)|(1<<DDB0);
	/* Enable SPI, Master, set clock rate fck/16 */
	//SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<CPOL)|(1<<CPHA);
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPIE);
	PORTB = PORTB | 0x01; //SS_INV high
}


void SPI_MasterTransmit(char cData)
{
	//* Start transmission */
	PORTB = PORTB &              0xFE; //SS_INV low
	SPDR = cData;
	/* Wait for transmission complete */
	
	while(!(SPSR & (1<<SPIF)))
	;	
	transmit_completed = 0;
	PORTB = PORTB | 0x01; //SS_INV high

}

void SPI_MasterTransmitCont(char cData)
{
	
	//* Start transmission */
	PORTB = PORTB & 0xFE; //SS_INV low
	SPDR = cData;
	/* Wait for transmission complete */	
	while(!(SPSR & (1<<SPIF)))
	;
	transmit_completed = 0;
	//PORTB = PORTB | 0x01; //SS_INV high
}


char SPI_MasterReceive()
{
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPIE)|(1<<CPHA);
	/* Start transmission */
	PORTB = PORTB & 0xFE; //SS_INV low
	SPDR = 0xFF;
	/* Wait for collsion bit*/
	while(!transmit_completed)
	;
	transmit_completed = 0;
	PORTB = PORTB | 0x01; //SS_INV high
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPIE);
	//showCode(serial_data);
	return serial_data;	
}

char SPI_MasterReceiveCont()
{
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPIE)|(1<<CPHA);
	/* Start transmission */
	PORTB = PORTB & 0xFE; //SS_INV low
	SPDR = 0xFF;
	/* Wait for collsion bit*/
	
	while(!transmit_completed)
	;
	transmit_completed = 0;
	//PORTB = PORTB | 0x01; //SS_INV high
	//SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPIE);
	//showCode(serial_data);
	
	return serial_data;			
}

ISR(SPI_STC_vect)
{
  serial_data = SPDR;
  transmit_completed = 1;
  bloed++;
}

